unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, VBScript_RegExp_55_TLB;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    FRegBuf: TRegExp;
    function ReverseSequence(const Sequence: String): String;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    FRegBuf := TRegExp.Create(nil);
    FRegBuf.IgnoreCase := True;
    FRegBuf.Global := True;
    Edit1Change(Edit1);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    FRegBuf.Free();
end;

procedure TForm1.Edit1Change(Sender: TObject);
var
    i: Integer;
    c: Char;
    S1: String;
    S2: String;
    S3: String;
    S4: String;
begin
    S1 := Edit1.Text;
    S2 := S1;
    S3 := S1;
    S4 := S1;

    for i := 1 to Length(S1) do
    begin
        c := S1[i];

        case c of

        'L':
            begin
                S2[i] := 'B';
                S3[i] := 'R';
                S4[i] := 'F';
            end;
        'F':
            begin
                S2[i] := 'L';
                S3[i] := 'B';
                S4[i] := 'R';
            end;
        'B':
            begin
                S2[i] := 'R';
                S3[i] := 'F';
                S4[i] := 'L';
            end;
        'R':
            begin
                S2[i] := 'F';
                S3[i] := 'L';
                S4[i] := 'B';
            end;
        'S':
            begin
                S2[i] := 'M';
                S3[i] := 's';
                S4[i] := 'm';
            end;
        'M':
            begin
                S2[i] := 's';
                S3[i] := 'm';
                S4[i] := 'S';
            end;

        end;
        
    end;

    S2 := StringReplace(S2, 's', 'S''', [rfReplaceAll]);
    S2 := StringReplace(S2, 'm', 'M''', [rfReplaceAll]);
    S3 := StringReplace(S3, 's', 'S''', [rfReplaceAll]);
    S3 := StringReplace(S3, 'm', 'M''', [rfReplaceAll]);
    S4 := StringReplace(S4, 's', 'S''', [rfReplaceAll]);
    S4 := StringReplace(S4, 'm', 'M''', [rfReplaceAll]);

    //  2x̔]͂ȂƓ
    S2 := StringReplace(S2, '''''', '', [rfReplaceAll]);
    S3 := StringReplace(S3, '''''', '', [rfReplaceAll]);
    S4 := StringReplace(S4, '''''', '', [rfReplaceAll]);

    Memo1.Clear();
    Memo1.Lines.Add('<i>(' + ReverseSequence(S1) + ')</i><br>' + S1);
    Memo1.Lines.Add('<i>(' + ReverseSequence(S2) + ')</i><br>' + S2);
    Memo1.Lines.Add('<i>(' + ReverseSequence(S3) + ')</i><br>' + S3);
    Memo1.Lines.Add('<i>(' + ReverseSequence(S4) + ')</i><br>' + S4);
end;

function TForm1.ReverseSequence(const Sequence: String): String;
var
    i: Integer;
    Matches, Match: OleVariant;
    Res: String;
    StrBuf: TStringList;
begin
    StrBuf := TStringList.Create();
    try
        //  s(ƌʃRNV󂯎)
        FRegBuf.Pattern := '([FBRLUDSME][^FBRLUDSME\s]*)';
        Matches := FRegBuf.Execute(Sequence);

        //  𒲂ׂ
        for i := Matches.Count - 1 downto 0 do
        begin
            //  o
            Match := Matches.Item[i];
            Res := Match.Value;

            //  ]
            Res := Res + '''';

            //  2x̔]͂ȂƓ
            Res := StringReplace(Res, '''''', '', [rfReplaceAll]);

            //  Xgɒǉ
            StrBuf.Add(Res);
        end;

        //  Xy[XŘA
        StrBuf.Delimiter := ' ';
        Result := StrBuf.DelimitedText;
    finally
        StrBuf.Free();
    end;
end;

end.
